/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ContactInfo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactInfo{}

// ContactInfo struct for ContactInfo
type ContactInfo struct {
	Email string `json:"email"`
	PhoneNumber *string `json:"phone_number,omitempty"`
	Webpage *string `json:"webpage,omitempty"`
	Address *string `json:"address,omitempty"`
	FullAddress *ContactInfoFullAddress `json:"full_address,omitempty"`
}

// NewContactInfo instantiates a new ContactInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactInfo(email string) *ContactInfo {
	this := ContactInfo{}
	this.Email = email
	return &this
}

// NewContactInfoWithDefaults instantiates a new ContactInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactInfoWithDefaults() *ContactInfo {
	this := ContactInfo{}
	return &this
}

// GetEmail returns the Email field value
func (o *ContactInfo) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *ContactInfo) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *ContactInfo) SetEmail(v string) {
	o.Email = v
}

// GetPhoneNumber returns the PhoneNumber field value if set, zero value otherwise.
func (o *ContactInfo) GetPhoneNumber() string {
	if o == nil || IsNil(o.PhoneNumber) {
		var ret string
		return ret
	}
	return *o.PhoneNumber
}

// GetPhoneNumberOk returns a tuple with the PhoneNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactInfo) GetPhoneNumberOk() (*string, bool) {
	if o == nil || IsNil(o.PhoneNumber) {
		return nil, false
	}
	return o.PhoneNumber, true
}

// HasPhoneNumber returns a boolean if a field has been set.
func (o *ContactInfo) HasPhoneNumber() bool {
	if o != nil && !IsNil(o.PhoneNumber) {
		return true
	}

	return false
}

// SetPhoneNumber gets a reference to the given string and assigns it to the PhoneNumber field.
func (o *ContactInfo) SetPhoneNumber(v string) {
	o.PhoneNumber = &v
}

// GetWebpage returns the Webpage field value if set, zero value otherwise.
func (o *ContactInfo) GetWebpage() string {
	if o == nil || IsNil(o.Webpage) {
		var ret string
		return ret
	}
	return *o.Webpage
}

// GetWebpageOk returns a tuple with the Webpage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactInfo) GetWebpageOk() (*string, bool) {
	if o == nil || IsNil(o.Webpage) {
		return nil, false
	}
	return o.Webpage, true
}

// HasWebpage returns a boolean if a field has been set.
func (o *ContactInfo) HasWebpage() bool {
	if o != nil && !IsNil(o.Webpage) {
		return true
	}

	return false
}

// SetWebpage gets a reference to the given string and assigns it to the Webpage field.
func (o *ContactInfo) SetWebpage(v string) {
	o.Webpage = &v
}

// GetAddress returns the Address field value if set, zero value otherwise.
func (o *ContactInfo) GetAddress() string {
	if o == nil || IsNil(o.Address) {
		var ret string
		return ret
	}
	return *o.Address
}

// GetAddressOk returns a tuple with the Address field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactInfo) GetAddressOk() (*string, bool) {
	if o == nil || IsNil(o.Address) {
		return nil, false
	}
	return o.Address, true
}

// HasAddress returns a boolean if a field has been set.
func (o *ContactInfo) HasAddress() bool {
	if o != nil && !IsNil(o.Address) {
		return true
	}

	return false
}

// SetAddress gets a reference to the given string and assigns it to the Address field.
func (o *ContactInfo) SetAddress(v string) {
	o.Address = &v
}

// GetFullAddress returns the FullAddress field value if set, zero value otherwise.
func (o *ContactInfo) GetFullAddress() ContactInfoFullAddress {
	if o == nil || IsNil(o.FullAddress) {
		var ret ContactInfoFullAddress
		return ret
	}
	return *o.FullAddress
}

// GetFullAddressOk returns a tuple with the FullAddress field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactInfo) GetFullAddressOk() (*ContactInfoFullAddress, bool) {
	if o == nil || IsNil(o.FullAddress) {
		return nil, false
	}
	return o.FullAddress, true
}

// HasFullAddress returns a boolean if a field has been set.
func (o *ContactInfo) HasFullAddress() bool {
	if o != nil && !IsNil(o.FullAddress) {
		return true
	}

	return false
}

// SetFullAddress gets a reference to the given ContactInfoFullAddress and assigns it to the FullAddress field.
func (o *ContactInfo) SetFullAddress(v ContactInfoFullAddress) {
	o.FullAddress = &v
}

func (o ContactInfo) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactInfo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["email"] = o.Email
	if !IsNil(o.PhoneNumber) {
		toSerialize["phone_number"] = o.PhoneNumber
	}
	if !IsNil(o.Webpage) {
		toSerialize["webpage"] = o.Webpage
	}
	if !IsNil(o.Address) {
		toSerialize["address"] = o.Address
	}
	if !IsNil(o.FullAddress) {
		toSerialize["full_address"] = o.FullAddress
	}
	return toSerialize, nil
}

type NullableContactInfo struct {
	value *ContactInfo
	isSet bool
}

func (v NullableContactInfo) Get() *ContactInfo {
	return v.value
}

func (v *NullableContactInfo) Set(val *ContactInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableContactInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableContactInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactInfo(val *ContactInfo) *NullableContactInfo {
	return &NullableContactInfo{value: val, isSet: true}
}

func (v NullableContactInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


